part of rad_textures;

class worley_sample {
  String _id;
  String get id { return _id; }
  final Vector3 v_center = new Vector3.zero();
  final double distance;
  worley_sample(Vector3 v_center_in, this.distance) {
    v_center_in.copyInto(v_center);
    _id = v_center_in.toString();
  }
}

List<worley_sample> worley1(double x, double y, double z, double p) {
  final distance = new Vector3.zero();

  const limit = 1.0;

  final v0 = new Vector3.zero();
  v0.setValues(x, y, z);
  List<worley_sample> samples = new List<worley_sample>();

  for(double offset_x = -limit; offset_x <= limit; offset_x += 1.0)
    for(double offset_y = -limit; offset_y <= limit; offset_y += 1.0)
      for(double offset_z = -limit; offset_z <= limit; offset_z += 1.0) {
        var v1 = PCellNoise3p(x + offset_x, y + offset_y, z + offset_z, p);
        distance.setValues(x.floor() + offset_x, y.floor() + offset_y, z.floor() + offset_z);
        distance.add(v1);
        distance.sub(v0);
        samples.add(new worley_sample(v1, distance.length));
      }
  samples.sort((s0, s1) => s0.distance.compareTo(s1.distance));
  return samples;
}
